require "my_util"
require "util"
local insert=table.insert
local handlers={
    on_build={},
    on_tick={},
    on_mined={},
    on_die={},
    on_trigger={},
    on_equipment={},
    on_label_key={},
    on_player_created={},
    on_gui={},
    on_init={},
    on_load={},
    on_mods_changed={},
    }
for k in pairs(handlers) do 
    _ENV[k]=function(handler) insert(handlers[k],handler)  end
end
new_storage=function(name,initial) 
    assert(not global[name]) 
    global[name]= initial or {} 
    return global[name] 
end
get_storage=function(name) return global[name]  end
ad_hoc_table=function(t,generate,restore) 
    if restore then for k,v in pairs(t) do
        restore(t,k,v)
    end end
    return setmetatable(t,{__index=function(t,k) t[k]= (generate and generate(t,k)) or {} return t[k] end})
end

define=function(key_value)
    for k,v in pairs(key_value) do
        assert(not _G[k])
        rawset(_G,k,v)
    end
end
setmetatable(_G,{__newindex=function(t,k,v) error("'"..k.."' unauthorized global creation\n"..debug.traceback(),2) end})

require "scripts/label"

require "scripts/radar"
require "scripts/transmitter"
require "scripts/squad"

require "scripts/landing"
require "scripts/drone_life"
--require "testing"

local gen_handler=function(hands)
    local N=#hands
    return function(event)
        for i=1,N do
            hands[i](event)
        end
    end
end

script.on_init(gen_handler(handlers.on_init))

script.on_load(gen_handler(handlers.on_load))

script.on_configuration_changed(gen_handler(handlers.on_mods_changed))

local e=defines.events
local dict={
    on_build={e.on_built_entity,e.on_robot_built_entity},
    on_mined={e.on_player_mined_entity,e.on_robot_mined_entity},
    on_tick={e.on_tick},
    on_die={e.on_entity_died},
    on_trigger={e.on_trigger_created_entity},
    on_equipment={e.on_player_placed_equipment,e.on_player_armor_inventory_changed,e.on_player_removed_equipment,e.on_player_joined},
    on_label_key={my"map-label-gui"},
    on_gui={e.on_gui_checked_state_changed,e.on_gui_click,e.on_gui_text_changed,},
    on_player_created={e.on_player_created},
}
for k,v in pairs(dict) do
    local f=gen_handler(handlers[k])
    for q,w in pairs(v) do
        script.on_event(w,f)
    end
end
