require "my_util"
local icon=function(name) return "__DroneCommand__/icons/"..name..".png" end

local drone=function(changes,color) 
    return add(
        (color or red)(
            derivative(
                raw["combat-robot"]["defender"],
                changes
            )
        )
    ) 
end
--local drone=function(changes) 
    --local p=derivative(raw["combat-robot"]["defender"],changes)
    ----print(p.name,"-")
    --return add(green(p)) 
--end
local capsule=function(drone)
    local name=drone.name
    add(green(derivative(raw.projectile["defender-capsule"],{
        name=name.."-projectile",
        action ={type = "direct",action_delivery =
            {type = "instant",target_effects =
                {{type = "create-entity",
                show_in_tooltip = true,
                entity_name = name,
    },}}}})))
    add(derivative(raw.capsule["defender-capsule"],{
        name=name.."-capsule",
        icon=drone.icon,
        capsule_action ={
          type = "throw",
          attack_parameters ={
            type = "projectile",ammo_category = "capsule",
            cooldown = 15, projectile_creation_distance = 0.6,
            range = 20,
            ammo_type ={
              category = "capsule",target_type = "position",
              action ={
                type = "direct",
                action_delivery ={
                  type = "projectile",
                  projectile = name.."-projectile",
                  starting_speed = 0.3
    }}}}}}))
end
local recipe=function(drone,ingredients,count) 
    return add(derivative(raw.recipe["defender-capsule"],{
        name=drone.name.."-recipe",
        ingredients=ingredients,
        result=drone.name.."-capsule",
        result_count=count or 1
    })) 
end
local technology=function(drone,image,prereqs,units,add_effects)
--local technology=function(drone,prereqs,units,add_effects)
    local effects={{type="unlock-recipe",recipe=drone.name.."-recipe"}}
    if add_effects then for k,v in pairs(add_effects) do
        table.insert(effects,v)
    end end
    return add(derivative(raw.technology["combat-robotics-2"],{
        name=drone.name.."-technology",
        prerequisites=prereqs,
        unit=units,
        effects=effects,
        icon=icon(image.file),
        icon_size = image.size or 128,
        }))
end

local FIVE_MINUTES=60 * 60 * 10 --okay, it is not 5
--local FIVE_MINUTES=60 * 60 * 20 --to hell with it
local protector=drone{name=my"protector",
    --flags = {"placeable-player", "player-creation", "placeable-off-grid",},
    max_health=300,
    speed=0.001,
    icon=icon"protector",
    resistances = {
        { type = "fire", percent = 100, decrease=2 },
        { type = "physical", decrease=5 },
        { type = "acid", percent = 50 },
    },
    time_to_live = FIVE_MINUTES,
    attack_parameters={ammo_type ={
        category = "bullet",
        action ={
          type = "direct",
          action_delivery ={
            type = "instant",
            source_effects ={
              type = "create-explosion",
              entity_name = "explosion-gunshot-small"
            },
            target_effects ={
              {
                type = "create-entity",
                entity_name = "explosion-hit"
              },
              {
                type = "damage",
                damage = { amount = 10 , type = "physical"}
              }
            }
          }
        }
      }
      }
}

capsule(protector)
recipe(protector,{
    {"submachine-gun",2,},
    {"piercing-rounds-magazine", 10},
    {"electronic-circuit", 10},
    })
technology(
    protector,
    {file="protector",size=32},
    {"combat-robotics-2",}
)

local exterminator=drone({name=my"exterminator",
    --flags = {"placeable-player", "player-creation", "placeable-off-grid",},
    max_health=600,
    speed=0.002,
    icon=icon"exterminator",
    resistances = {
        { type = "fire", percent = 100 },
        { type = "physical", decrease=10, percent=20 },
        { type = "acid", percent = 50, decrease=3 },
    },
    time_to_live=FIVE_MINUTES,
    attack_parameters={
        ammo_type ={
            category = "flamethrower",
            target_type = "position",
            clamp_position = true,
            action ={
              type = "direct",
              action_delivery ={
                type = "stream",
                stream = "handheld-flamethrower-fire-stream",
                max_length = 15,
                duration = 160,
              }
            }
        }
    }
},
green)
capsule(exterminator)
recipe(exterminator,{
    {"flamethrower",2,},
    {"fast-inserter",2},
    {"processing-unit",1},
})
technology(
    exterminator,
    {file="exterminator",size=32},
    {"combat-robotics-3"},
    {
        ingredients={
            {"science-pack-1", 1},
            {"science-pack-2", 1},
            {"science-pack-3", 1},
            {"military-science-pack", 3},
            {"high-tech-science-pack", 1}
        },
        count=100,time=30,
    }
)

local cargo=drone({name=my"cargo-drone",
    --flags = {"placeable-player", "player-creation", "placeable-off-grid",},
    icon=icon"cargo",
    speed=0.001,
    time_to_live=2*FIVE_MINUTES,
    ammo_type=delet,},
    magenta
)
capsule(cargo)
recipe(cargo,{
    {"flying-robot-frame", 1},
    {"accumulator",1}
})
technology(
    cargo,
    {file="cargo",size=32},
    {"logistic-robotics","electric-energy-accumulators-1"},
    {
        ingredients={{"science-pack-1", 2},{"science-pack-2", 1,}},count=150,time=30
    }
)

local construction=drone({name=my"construction-drone",
    --flags = {"placeable-player", "player-creation", "placeable-off-grid",},
    icon=icon"construction",
    speed=0.001,
    time_to_live=2*FIVE_MINUTES,
    ammo_type=delet,},
    yellow
)
capsule(construction)
local packed_roboport=add(derivative(raw.recipe["defender-capsule"],{
    name=my"packed-roboport",
    ingredients={{"roboport",1},{my"packed-robots",1},{"repair-pack",20}},
    result=my"packed-roboport",
}))
local packed_robots=add(derivative(raw.recipe["defender-capsule"],{
    name=my"packed-robots",
    ingredients={{"construction-robot",10},{"logistic-robot",10}},
    result=my"packed-robots",
}))
add(derivative(raw.item.coal,{name=my"packed-roboport",
    icon=icon"packed_roboport",
}))
add(derivative(raw.item.coal,{name=my"packed-robots",
    icon=icon"packed_robots",
}))

recipe(construction,{
    {"flying-robot-frame", 1},
    {my"packed-roboport",1},
})
technology(
    construction,
    {file="construction",size=32},
    {"construction-robotics"},
    {
        ingredients={{"science-pack-1", 2},{"science-pack-2", 2,}},count=150,time=30
    },
    {
        {type="unlock-recipe",recipe=packed_robots.name},
        {type="unlock-recipe",recipe=packed_roboport.name},
    }
)
