require "my_util"

add(derivative(raw["item-subgroup"]["virtual-signal-special"],{
    name=my"radar-entities",
    group=my"drone-command-signals",
    order='z-a-s'
}))

local unknown_icon="__core__/graphics/favourite.png"
local template=raw.item.accumulator
local generate_item=function(prototype)
    add(derivative(template,{
        name=prototype.name,
        icon=prototype.icon or unknown_icon,
        place_result=prototype.name,
        subgroup=my"radar-entities",
    }))
end

local cats={--entity types the radar must surely detect
    "unit-spawner",
    "turret",
    "ammo-turret",
    "electric-turret",
    "unit",
    "combat-robot",
}
local ents_with_items={}
for name,item in pairs(raw.item) do
    local pr= item.place_result
    --print(pr)
    if pr then
        for _,cat in pairs(cats) do
            --print(cat,raw[cat][pr])
            if raw[cat][pr] then
                ents_with_items[pr]=true
            end
        end
    end
end
--print(serpent.block(ents_with_items))
for _,cat in pairs(cats) do
    for name,prototype in pairs(raw[cat]) do
        if not ents_with_items[name] then
            generate_item(prototype)
        end
    end
end

add(derivative(raw.item.coal,{
    name=my"unexistant-item",
    subgroup=my"radar-entities",
    icon="__core__/graphics/too-far.png",
    order="z-z-z"
}))
