--This file implements killing drones one tick before expiry
--this the .die() method results in the event, unlike their internal timer

require "scripts/drones"
local TTL_OFFSET=61

local DRONES
local DATA
on_init(function()
    DATA=new_storage("grim-reaper")
    DRONES=get_storage("drone-types")
end)
on_load(function()
    DATA=get_storage("grim-reaper")
    DRONES=get_storage("drone-types")
end)
local insert=table.insert
on_trigger(function(event)
    local e=event.entity
    if not DRONES[e.name] then return end
    local D=DATA
    local ttl=e.time_to_live
    local tick=event.tick
    local T=ttl+tick-TTL_OFFSET
    D[T]=D[T] or {}
    insert(D[T],e)
end)
on_tick(function(event)
    local t=event.tick
    --print(serpent.block(DATA))
    if DATA[t] then
        --print('kill')
        local D=DATA[t]
        local k=0
        for i=1,#D do
            local d=D[i]
            --print(d.name)
            if d.valid then 
                d.die() 
                k=k+1
            end
            DATA[t]=nil
        end
        --print('killed',k,'of',#D)
    end
end)
local register_drones=function(drones)
    local D=DATA
    local tick=game.tick
    for _,e in pairs(drones) do
        local ttl=e.time_to_live
        local T=ttl+tick-TTL_OFFSET
        assert(e.valid)
        D[T]=D[T] or {}
        insert(D[T],e)
    end
end

return {register_drones=register_drones}
