--[[Find all drones and their corresponding dummy projectiles and crash items
]]
require "my_util"
local compressor=require"lib/compressor"
local generated_params=require"data_u/generated"


local mt
local drones
on_init(function()
    drones=setmetatable(new_storage("drone-types"),mt):init()
end)
on_load(function()
    drones=setmetatable(get_storage("drone-types"),mt)
end)
on_mods_changed(function()
    drones:init()
end)


local PREFIX=generated_params.PREFIX
local DUMMY_NAME=generated_params.DUMMY_NAME
local DUMMY_NAME2=generated_params.DUMMY_NAME2

mt={__index={
    init=function(me)
        local item_prototypes=game.item_prototypes
        local prototypes=game.entity_prototypes
        local drone2caps,spawned_per_item
        
        do
            local compressed_strings={}
            local i=1
            local n=DUMMY_NAME..i
            local skip=#PREFIX+1
            while prototypes[n] do
                --print(prototypes[n].order)
                table.insert(compressed_strings,prototypes[n].order:sub(skip))
                i=i+1
                n=DUMMY_NAME..i
            end
            drone2caps=compressor.uncompress(table.concat(compressed_strings))
            --redo me:
            local compressed_strings={}
            local i=1
            local n=DUMMY_NAME2..i
            local skip=#PREFIX+1
            while prototypes[n] do
                --print(prototypes[n].order)
                table.insert(compressed_strings,prototypes[n].order:sub(skip))
                i=i+1
                n=DUMMY_NAME2..i
            end
            spawned_per_item=compressor.uncompress(table.concat(compressed_strings))
        end
        for n,p in pairs(prototypes) do
            if p.type=="combat-robot" then
                local projectile= "deploying#-"..my(n)
                local lightly_damaged= "spent#-"..my(n)
                local heavily_damaged="wrecked#-"..my(n)
                local capsule=drone2caps[n]
                local prototype=p
                
                if prototypes[projectile] and item_prototypes[lightly_damaged] and item_prototypes[heavily_damaged] then
                    me[n]={
                        name=n,
                        projectile=projectile,
                        lightly_damaged=lightly_damaged,
                        heavily_damaged=heavily_damaged,
                        capsule=capsule,
                        prototype=prototype,
                        multiplier=spawned_per_item[n],
                    }
                end
            end
        end
        return me
    end,
    slowest=function(me,drone_names)
        local speed, drone = 100, nil
        for _,n in pairs(drone_names) do
            if me[n] then
                local p=me[n].prototype
                --print(p.speed)
                if p.speed<speed then
                    drone=me[n]
                    speed=p.speed
                end
            end
        end
        return speed,drone
    end,
    capsule_lookups=function(me)
        local r={}
        for k,v in pairs(me) do
            r[v.capsule]=k
        end
        return r
    end,
}}
--return drones
--return setmetatable({},{__index=function(t,k) t[k]=drones[k] return drones[k] end})--a hack to because actual table is created after the file must return the value
